Private Sub Migrate_Data()
On Error GoTo Err_Handler
svr.LogEvent "Entering " & App.Title & ":frmWizard.Migrate_Data()", etFullDebug

Dim W As Integer
Dim X As Integer
Dim Y As Integer
Dim i As Integer
Dim j As Integer
Dim Z As Integer

Dim bPrimaryKeyAdded As Boolean
Dim bIsForeignKey As Boolean

Dim szRelatedCols As String
Dim szTmpFKName As String

Dim szQryStr As String
Dim szTemp1 As String
Dim szTemp2 As String
Dim Start As Single
Dim rsTemp As New Recordset
Dim loFlag As Boolean
Dim Tuples As Long
Dim Fields As String
Dim Values As String
Dim fNum As Integer
Dim szValue As String
Dim vValue As Variant
Dim vDate As Variant

Dim lVer As Single

'   06/29/01 Matthew MacSuga (AutoIncrement Fix)
'   Check for existance of an auto increment field
Dim auto_increment_on As Integer
Dim auto_increment_field_name As String
Dim auto_increment_count As Long
Dim auto_increment_table As String
Dim auto_increment_query As String
Dim auto_increment_rs As New Recordset
Dim auto_increment_sequencename As String

'Johnm - for checking for the existance of a destination table to drop
Dim bDrop As Boolean
'Temp variables to reduce if/then code bloat on table drop
Dim szDropNamespace As String
Dim szDropTablename As String
Dim szDropTableConcatenation As String

'AC - for collecting field names for query to fix milliseconds issue
Dim szSQLDataQuery As String
Dim szFieldName As String
'AC - end

  StartMsg "Migrating database..."
  lVer = svr.dbVersion.VersionNum
  pbStatus.Max = lstData.ListCount
  pbStatus.Value = 0
  Start = Timer
  szDatabase = lstDatabase.SelectedItem.Text
  svr.LogEvent "Migration from " & cnLocal.ConnectionString & " to " & szDatabase & " starting.", etMiniDebug
  
  If chkNotNull.Value = 1 Then svr.LogEvent "NOT NULL rules being honoured.", etMiniDebug
  If chkLCaseTables.Value = 1 Then svr.LogEvent "Table names being converted to lowercase.", etMiniDebug
  If chkLCaseColumns.Value = 1 Then svr.LogEvent "Column names being converted to lowercase.", etMiniDebug
  If chkLCaseIndexes.Value = 1 Then svr.LogEvent "Index names being converted to lowercase.", etMiniDebug
  If chkDropExistingTables.Value = 1 Then svr.LogEvent "Pre-existing destination tables will be dropped.", etMiniDebug
  If chkPerTableTrans.Value = 1 Then svr.LogEvent "Using Per-Table Commits", etMiniDebug

  'Begin a transaction.
  '1/18/2003 John Wells
  If chkPerTableTrans.Value = 0 Then
    svr.Databases(szDatabase).Execute "BEGIN"
  End If
          
  For X = 0 To lstData.ListCount - 1
  
    'AC 20030908 millisecond fix
    szSQLDataQuery = ""
    'AC - end
  
    '1/18/2003 John Wells
    'if we want one transaction per table ported...
    If chkPerTableTrans.Value = 1 Then
        svr.LogEvent "Beginning transaction...", etMiniDebug
        txtStatus.Text = txtStatus.Text & "Beginning transaction..." & vbCrLf
        txtStatus.SelStart = Len(txtStatus.Text)
        Me.Refresh
        svr.Databases(szDatabase).Execute "BEGIN"
    End If
            
    svr.LogEvent "Creating table: " & lstData.List(X), etMiniDebug
    txtStatus.Text = txtStatus.Text & "Creating table: " & lstData.List(X) & vbCrLf
    txtStatus.SelStart = Len(txtStatus.Text)
    Me.Refresh
    
    'Create the table
    
    szTemp1 = ""  'Added 1/30/2001 Rod Childers Variables not being set to ""
    szTemp2 = ""
    
    szQryStr = ""
    
    '****
    'Johnm - If checked by the user, drop the matching destination table
    If chkDropExistingTables = 1 Then
      bDrop = False

      If chkLCaseTables.Value = 0 Then
        szDropTablename = lstData.List(X)
      Else
        szDropTablename = LCase(lstData.List(X))
      End If

      If lVer >= 7.3 Then
        szDropNamespace = szNamespace
        szDropTableConcatenation = fmtID(szNamespace) & "." & fmtID(szDropTablename)
      Else
        szDropNamespace = "public"
        szDropTableConcatenation = szDropTablename
      End If

      'Set drop boolean based on whether the table was found in the destination DB
      bDrop = svr.Databases(szDatabase).Namespaces(szDropNamespace).Tables.Exists(szDropTablename)

      'Only attempt to drop the tables if they were found in the destination postgres database
      If bDrop = True Then
        txtStatus.Text = txtStatus.Text & "Dropping table " & szDropTablename & vbCrLf
        szQryStr = szQryStr & "DROP TABLE " & szDropTableConcatenation & "; "
      End If
    End If
    'Johnm - table dropping code
    '****
    
    loFlag = False
    If lVer >= 7.3 Then
      If chkLCaseTables.Value = 0 Then
        szQryStr = szQryStr & "CREATE TABLE " & fmtID(szNamespace) & "." & fmtID(lstData.List(X)) & " ( "
      Else
        szQryStr = szQryStr & "CREATE TABLE " & fmtID(szNamespace) & "." & fmtID(LCase(lstData.List(X))) & " ( "
      End If
    Else
      If chkLCaseTables.Value = 0 Then
        szQryStr = szQryStr & "CREATE TABLE " & fmtID(lstData.List(X)) & " ( "
      Else
        szQryStr = szQryStr & "CREATE TABLE " & fmtID(LCase(lstData.List(X))) & " ( "
      End If
    End If
    
    '   06/29/01 Matthew MacSuga (AutoIncrement Fix)
    '   Check for existance of an auto increment field
    '   20020110 Artur Maslag    (AutoIncrement Fix)
    '   Added funtion for correctly checking this property
    auto_increment_on = 0
    auto_increment_count = 0
    auto_increment_field_name = ""
    If chkLCaseTables.Value = 0 Then
      auto_increment_table = lstData.List(X)
    Else
      auto_increment_table = LCase(lstData.List(X))
    End If
    auto_increment_query = ""
    
    '****
    'Johnm - MSSQL Autonumber code NOTE: using some of the variables defined for the Access autonumber code
    'NOTE: currently only tested on MSSQL Server 7.0/NT4
    If optType(2).Value = True Then
        'The following query should pull a record that contains the autonumber column if one exists for the table
        auto_increment_query = " select (syscolumns.status & 128) as isidentity , sysobjects.name as tablename, syscolumns.name as columnname " & _
        " From " & _
        " sysobjects inner join syscolumns on sysobjects.id = syscolumns.id " & _
        " inner join systypes on syscolumns.type = systypes.type " & _
        " where sysobjects.type = 'U' AND (syscolumns.status & 128) = 128 AND " & _
        " sysobjects.name = '" & auto_increment_table & "'"
            
        '   Perform the query
        auto_increment_rs.Open auto_increment_query, cnLocal, 3, 1
        'If a record was found, then there is an autonumber for this table
        If auto_increment_rs.EOF = False Then
            'Johnm - setting boolean and variables to utilize the existing MSDASQL code
            auto_increment_on = 1
            If chkLCaseColumns.Value = 0 Then
              auto_increment_field_name = auto_increment_rs("columnname")
            Else
              auto_increment_field_name = LCase(auto_increment_rs("columnname"))
            End If
        End If
        If auto_increment_rs.State <> adStateClosed Then auto_increment_rs.Close
        Set auto_increment_rs = Nothing
        auto_increment_query = ""
    End If
    'Johnm - End of MSSQL Autonumber code
    '****
    
    '   Only do this if it's an access database
    If optType(0).Value = True Then
      For Y = 0 To catLocal.Tables(lstData.List(X)).Columns.Count - 1
        If catLocal.Tables(lstData.List(X)).Columns(Y).Type = adInteger Then
          If bIsAutoIncrement(catLocal.Tables(lstData.List(X)).Columns(Y).Properties("AutoIncrement")) = True Then ' AM 20020110
            auto_increment_on = 1
            
            If chkLCaseColumns.Value = 0 Then
              auto_increment_field_name = catLocal.Tables(lstData.List(X)).Columns(Y).Name
            Else
              auto_increment_field_name = LCase(catLocal.Tables(lstData.List(X)).Columns(Y).Name)
            End If
            
            Exit For
          End If
        End If
      Next Y
    End If 'Johnm - Moved end if here so that both blocks of autoincrement code can use this section
    
      If auto_increment_on = 1 Then
        auto_increment_query = "SELECT MAX(" & szQuoteChar & auto_increment_field_name & szQuoteChar & ") AS RECCOUNT FROM " & szQuoteChar & auto_increment_table & szQuoteChar
            
        '   Perform the query
        auto_increment_rs.Open auto_increment_query, cnLocal, 3, 1
        If auto_increment_rs.RecordCount = 1 Then
          '   Set auto_increment_count = MAX(fieldname) + 1 (to start at next record)
          If Not (IsNull(auto_increment_rs("RECCOUNT"))) Then
            auto_increment_count = Val(auto_increment_rs("RECCOUNT")) + 1
          Else
            auto_increment_count = 1
          End If
        End If
            
        '   Destroy what I created
        If auto_increment_rs.State <> adStateClosed Then auto_increment_rs.Close
        Set auto_increment_rs = Nothing
        
        'Reset querystring to empty for reuse
        auto_increment_query = ""
                
        'Johnm - assuming that if we are to drop conflicting tables, we should also drop conflicting sequences
        If chkDropExistingTables = 1 Then
            auto_increment_sequencename = Left(auto_increment_table & "_" & auto_increment_field_name & "_seq", 31)
            If svr.Databases(szDatabase).Namespaces(szDropNamespace).Sequences.Exists(auto_increment_sequencename) Then
                '   Set the PostgreSQL query
                If lVer >= 7.3 Then
                  auto_increment_query = "DROP SEQUENCE " & fmtID(szNamespace) & "." & fmtID(auto_increment_table & "_" & auto_increment_field_name & "_seq") & ";"
                Else
                  auto_increment_query = "DROP SEQUENCE " & fmtID(auto_increment_table & "_" & auto_increment_field_name & "_seq") & ";"
                End If
                'Johnm - added status update to notify of sequence creation
                txtStatus.Text = txtStatus.Text & "Dropping sequence " & auto_increment_table & "_" & auto_increment_field_name & "_seq" & vbCrLf
            Else
                'Johnm - added status update to notify of sequence creation
                'txtStatus.Text = txtStatus.Text & "Sequence " & auto_increment_sequencename & " not found " & vbCrLf
            End If
        End If
        
        'Johnm - added status update to notify of sequence creation
        txtStatus.Text = txtStatus.Text & "Creating sequence " & auto_increment_table & "_" & auto_increment_field_name & "_seq" & vbCrLf

        '   Set the PostgreSQL query
        If lVer >= 7.3 Then
          auto_increment_query = auto_increment_query & "CREATE SEQUENCE " & fmtID(szNamespace) & "." & fmtID(auto_increment_table & "_" & auto_increment_field_name & "_seq") & " START " & auto_increment_count
        Else
          auto_increment_query = auto_increment_query & "CREATE SEQUENCE " & fmtID(auto_increment_table & "_" & auto_increment_field_name & "_seq") & " START " & auto_increment_count
        End If
      Else
        auto_increment_query = ""
      End If
    
    'Johnm - Former location of "if access" if
    
    '   End AutoIncrement Fix
            
    '   07/02/01 - Matthew MacSuga - Put columns in original order fix
    Dim rsTemp_Column As New Recordset
    Dim K As Integer
    Dim sqlQ As String
    Dim newColumnArray()
    Dim ColCount As Integer
    
    '   Generate query to get column names
    sqlQ = "SELECT * FROM " & szQuoteChar & lstData.List(X) & szQuoteChar & " WHERE 1=2"
    rsTemp_Column.Open sqlQ, cnLocal, 3, 1
    
    ColCount = rsTemp_Column.Fields.Count - 1
    '   Set up the temporary copy array - sloppy sort
    ReDim newColumnArray(ColCount)
    For K = 0 To ColCount
        For Y = 0 To catLocal.Tables(lstData.List(X)).Columns.Count - 1
            If catLocal.Tables(lstData.List(X)).Columns(Y).Name = rsTemp_Column.Fields(K).Name Then
                newColumnArray(K) = catLocal.Tables(lstData.List(X)).Columns(Y).Name
                
                Exit For
            End If
        Next
    Next
    
    If rsTemp_Column.State <> adStateClosed Then rsTemp_Column.Close
    Set rsTemp_Column = Nothing
    

    
    For Y = 0 To catLocal.Tables(lstData.List(X)).Columns.Count - 1
      'DJP 2001-07-02 Don't migrate the oid column on PostgreSQL Databases!
      If Not ((cnLocal.Properties("DBMS Name") = "PostgreSQL") And (newColumnArray(Y) = "oid")) Then
        If chkLCaseColumns.Value = 0 Then
          szTemp1 = szTemp1 & fmtID(catLocal.Tables(lstData.List(X)).Columns(newColumnArray(Y)).Name)
        Else
          szTemp1 = szTemp1 & fmtID(LCase(catLocal.Tables(lstData.List(X)).Columns(newColumnArray(Y)).Name))
        End If
        'AC 20030908 millisecond fix
        szFieldName = fmtID(LCase(catLocal.Tables(lstData.List(X)).Columns(newColumnArray(Y)).Name))
        'AC end
        Select Case catLocal.Tables(lstData.List(X)).Columns(newColumnArray(Y)).Type
        ' AM 20020110
        ' Regkey was wrong - "Software\pgAdmin\Type Map"
        ' Correct value is "Software\pgAdmin II\Migration Wizard\Type Map"
          Case adBigInt
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "BigInt", "int8")
          Case adBinary
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "Binary", "text")
            loFlag = True
          Case adBoolean
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "Boolean", "bool")
          Case adBSTR
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "BSTR", "bytea")
          Case adChapter
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "Chapter", "int4")
          Case adChar
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "Char", "char")
          Case adCurrency
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "Currency", "money")
          Case adDate
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "Date", "date")
          Case adDBDate
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "DBDate", "date")
          Case adDBTime
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "DBTime", "time")
          Case adDBTimeStamp
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "DBTimestamp", "timestamp")
          Case adDecimal
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "Decimal", "numeric")
          Case adDouble
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "Double", "float8")
          Case adEmpty
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "Empty", "text")
          Case adError
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "Error", "int4")
          Case adFileTime
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "FileTime", "datetime")
          Case adGUID
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "GUID", "text")
          Case adInteger
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "Integer", "int4")
          Case adLongVarBinary
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "LongVarBinary", "lo")
            loFlag = True
          Case adLongVarChar
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "LongVarChar", "text")
          Case adLongVarWChar
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "LongVarWChar", "text")
          Case adPropVariant
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "PropVariant", "text")
          Case adSingle
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "Single", "float4")
          Case adSmallInt
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "SmallInt", "int2")
          Case adTinyInt
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "TinyInt", "int2")
          Case adUnsignedBigInt
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "UnsignedBigInt", "int8")
          Case adUnsignedInt
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "UnsignedInt", "int4")
          Case adUnsignedSmallInt
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "UnsignedSmallInt", "int2")
          Case adUnsignedTinyInt
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "UnsignedTinyInt", "int2")
          Case adUserDefined
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "UserDefined", "text")
          Case adVarBinary
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "VarBinary", "lo")
            loFlag = True
          Case adVarChar
            '1/16/2001 Rod Childers
            'Changed VarChar to default to VarChar
            'Text in Access is = VarChar in PostgreSQL
            'Memo in Access is = text in PostgreSQL
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "VarChar", "varchar")
          Case adVarWChar
            '1/16/2001 Rod Childers
            'Changed VarWChar to default to VarChar
            'Text in Access is = VarChar in PostgreSQL
            'Memo in Access is = text in PostgreSQL
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "VarWChar", "varchar")
          Case adWChar
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "WChar", "text")
          Case adNumeric
            ' AM 20020110
            ' I add this type to mappings
          
            szTemp2 = RegRead(HKEY_CURRENT_USER, "Software\pgAdmin II\Migration Wizard\Type Map", "Numeric", "numeric")
          Case Else
          szTemp2 = "text"
        End Select
        If szTemp2 = "bpchar" Or szTemp2 = "char" Or szTemp2 = "varchar" Then
          If catLocal.Tables(lstData.List(X)).Columns(newColumnArray(Y)).DefinedSize = 0 Then
            szTemp2 = szTemp2 & "(1)"
          Else
            'Varchar cannot exceed 8088 chars!
            If catLocal.Tables(lstData.List(X)).Columns(Y).DefinedSize > 8088 Then
              txtStatus.Text = txtStatus.Text & "  The 'varchar' field " & catLocal.Tables(lstData.List(X)).Columns(newColumnArray(Y)).Name & " is too long and has been converted to type 'text'" & vbCrLf
              txtStatus.SelStart = Len(txtStatus.Text)
              svr.LogEvent "The 'varchar' field " & catLocal.Tables(lstData.List(X)).Columns(newColumnArray(Y)).Name & " is too long and has been converted to type 'text'", etMiniDebug
              szTemp2 = "text"
            Else
              szTemp2 = szTemp2 & "(" & catLocal.Tables(lstData.List(X)).Columns(newColumnArray(Y)).DefinedSize & ")"
            End If
          End If
        End If
        ' AM 20020110
        ' driver don't returns correct values - setting to default 18,4
        If szTemp2 = "numeric" Then
          If catLocal.Tables(lstData.List(X)).Columns(newColumnArray(Y)).Type = adNumeric Then
            szTemp2 = szTemp2 & "(" & catLocal.Tables(lstData.List(X)).Columns(newColumnArray(Y)).Precision & "," & catLocal.Tables(lstData.List(X)).Columns(newColumnArray(Y)).NumericScale & ")"
          Else
            szTemp2 = szTemp2 & "(" & "18" & "," & "4" & ")"
          End If
        End If
      
        'AC 20030908 millisecond fix
        If (optType(2).Value = True) Then
          If szTemp2 = "timestamp" Then
            szFieldName = "CONVERT(char(30), " & szFieldName & ", 121) as " & szFieldName
          End If
        End If
        'AC end
      
        If (szSQLDataQuery = "") Then
         szSQLDataQuery = szFieldName
        Else
         szSQLDataQuery = szSQLDataQuery & ", " & szFieldName
        End If
      
        ' Matthew MacSuga Auto Increment Fix
        If auto_increment_on = 1 Then
          If LCase(newColumnArray(Y)) = LCase(auto_increment_field_name) Then
            szTemp2 = szTemp2 & " DEFAULT nextval('" & QUOTE & auto_increment_table & "_" & auto_increment_field_name & "_seq" & QUOTE & "')"
          End If
        End If
        
        szTemp1 = szTemp1 & " " & szTemp2
        If chkNotNull.Value = 1 Then
          If (catLocal.Tables(lstData.List(X)).Columns(newColumnArray(Y)).Attributes And adColNullable) = False Then szTemp1 = szTemp1 & " NOT NULL"
        End If
        szTemp1 = szTemp1 & ", "
      End If
    Next Y
    
    If Len(szTemp1) > 2 Then
      
      '1/14/2001 Rod Childers
      'See if the user wants PrimaryKeys created
      bPrimaryKeyAdded = False
      If chkPrimaryKey.Value = 1 Then
        
        'loop through indexes for table, look for Primary Key
        For j = 0 To catLocal.Tables(lstData.List(X)).Indexes.Count - 1
          If catLocal.Tables(lstData.List(X)).Indexes(j).PrimaryKey = True Then
            'Primary Key found, set flag
            bPrimaryKeyAdded = True
            
            'Primary key will be added, keep the extra , at the end of field list
            'and add it to the query string
            szQryStr = szQryStr & szTemp1
            
            szQryStr = szQryStr & " PRIMARY KEY("
            
            'Get the field names of the fields in the primary key
            For i = 0 To catLocal.Tables(lstData.List(X)).Indexes(j).Columns.Count - 1
              If chkLCaseColumns.Value = 0 Then
                szQryStr = szQryStr & fmtID(catLocal.Tables(lstData.List(X)).Indexes(j).Columns(i).Name) & ", "
              Else
                szQryStr = szQryStr & fmtID(LCase(catLocal.Tables(lstData.List(X)).Indexes(j).Columns(i).Name)) & ", "
              End If
            Next i
          End If
        Next j
      End If
       
      If bPrimaryKeyAdded = True Then
        'Trim off the extra , at the end
        szQryStr = Left(szQryStr, (Len(szQryStr) - 2))
        'add a ) to close the field statment fo the PRIMARY KEY
        szQryStr = szQryStr & ")"
      Else
        'No Primary key will be added, trim off the extra , at the end of the fields
        szTemp1 = Mid(szTemp1, 1, Len(szTemp1) - 2)
        szQryStr = szQryStr & szTemp1
      End If
       
      szQryStr = szQryStr & " )"
      
      ' Matthew MacSuga Auto-Increment Fix
      If auto_increment_on = 1 Then svr.Databases(szDatabase).Execute auto_increment_query
      ' End Auto-Increment Fix
      
      svr.Databases(szDatabase).Execute szQryStr
      
      '
      'Copy the data if required
      '
      'Note: We don't use fmtID during the copy process because it makes things horrendously slow.
      '      Instead, we quote everything. It's ugly, but a shedload quicker
      If lstData.Selected(X) = True Then
      
        'Warn that BLOBS are being ignored.
        If loFlag = True Then
          txtStatus.Text = txtStatus.Text & "  Binary data was found and NOT copied." & vbCrLf
          txtStatus.SelStart = Len(txtStatus.Text)
          svr.LogEvent "Binary data was found and NOT copied.", etMiniDebug
          Me.Refresh
        End If
        Tuples = 0
        txtStatus.Text = txtStatus.Text & "  Copying data..." & vbCrLf
        txtStatus.SelStart = Len(txtStatus.Text)
        Me.Refresh
        svr.LogEvent "Migrating Data from: " & lstData.List(X), etMiniDebug
        'AC 20030908 millisecond fix
        If (optType(2).Value = True) Then
          svr.LogEvent "Executing: SELECT " & szSQLDataQuery & " FROM " & szQuoteChar & lstData.List(X) & szQuoteChar, etMiniDebug
          rsTemp.Open "SELECT " & szSQLDataQuery & " FROM " & szQuoteChar & lstData.List(X) & szQuoteChar, cnLocal, adOpenForwardOnly
        Else
          svr.LogEvent "Executing: SELECT * FROM " & szQuoteChar & lstData.List(X) & szQuoteChar, etMiniDebug
          rsTemp.Open "SELECT * FROM " & szQuoteChar & lstData.List(X) & szQuoteChar, cnLocal, adOpenForwardOnly
        End If
        'AC end
        
        While Not rsTemp.EOF
          If lVer >= 7.3 Then
            If chkLCaseTables.Value = 0 Then
              szQryStr = "INSERT INTO " & QUOTE & szNamespace & QUOTE & "." & QUOTE & lstData.List(X) & QUOTE
            Else
              szQryStr = "INSERT INTO " & QUOTE & szNamespace & QUOTE & "." & QUOTE & LCase(lstData.List(X)) & QUOTE
            End If
          Else
            If chkLCaseTables.Value = 0 Then
              szQryStr = "INSERT INTO " & QUOTE & lstData.List(X) & QUOTE
            Else
              szQryStr = "INSERT INTO " & QUOTE & LCase(lstData.List(X)) & QUOTE
            End If
          End If
          
          For Z = 0 To rsTemp.Fields.Count - 1
          
            ' There is a bug in the Foxpro driver (surprise, surprise :-)). Memo fields
            ' can be accessed once, and once only. Subsequent attempts return NULL. To
            ' get round this, we copy to a variant, check that for a NULL value (which might
            ' be wanted), then copy it to a string and use as required.
            ' This works - don't mess with it :-) - DJP.
            vValue = rsTemp.Fields(Z).Value
            If ((Not IsNull(vValue)) And (rsTemp.Fields(Z).Type <> adLongVarBinary) And (rsTemp.Fields(Z).Type <> adVarBinary) And (rsTemp.Fields(Z).Type <> adBinary)) Then
              szValue = vValue & ""
              If chkLCaseColumns.Value = 0 Then
                Fields = Fields & QUOTE & rsTemp.Fields(Z).Name & QUOTE & ", "
              Else
                Fields = Fields & QUOTE & LCase(rsTemp.Fields(Z).Name) & QUOTE & ", "
              End If
            
              Select Case rsTemp.Fields(Z).Type
                 ' 04/24/2001 Jean-Michel POURE
                 ' Useful tricks to avoid bugs in non-English systems :
                 ' replace comma with dots in numerical values
                 ' and get rid of money acronyms (like FF for example)
                  Case adCurrency, adDouble, adSingle, adDecimal, adNumeric
                      Values = Values & "'" & Str(Val(Replace(szValue, ",", "."))) & "', "
                 
                 ' Another useful trick to avoid bugs in non-English systems :
                 ' Convert 'True' or 'Vrai' or 'T' into -1
                 ' and 'False' or 'Faux' or 'F' into 0
                 ' In PostgreSQL driver uncheck Bool as Char
                  Case adBoolean
                      If (szValue = "F") Then szValue = "False"
                      If (szValue = "T") Then szValue = "True"
                      Values = Values & "'" & CBool(szValue) * "-1" & "', "
                  
                  'We used to have a bit of a hack here, but if the recordset thinks it has a valid date
                  'then it must do. Format to ISO (8601? - I can never remember!) will automatically add
                  '1899-12-30 if only a time is actually in the string
                  Case adDate, adDBDate, adDBTimeStamp
                    vDate = szValue
                    Values = Values & "'" & Year(vDate) & "-" & Month(vDate) & "-" & Day(vDate) & " " & Hour(vDate) & ":" & Minute(vDate) & ":" & Second(vDate) & "', "

                    ' Text values and others
                  Case Else
                    Values = Values & "'" & Replace(Replace((szValue), "\", "\\"), "'", "''") & "', "
               End Select
             End If
          Next
        
          Fields = Mid(Fields, 1, Len(Fields) - 2)
          Values = Mid(Values, 1, Len(Values) - 2)
          
          szQryStr = szQryStr & " (" & Fields & ") VALUES (" & Values & ")"
        
          svr.Databases(szDatabase).Execute szQryStr
          Tuples = Tuples + 1
          Fields = ""
          Values = ""
          DoEvents
          rsTemp.MoveNext
        Wend
        If rsTemp.State <> adStateClosed Then rsTemp.Close
        txtStatus.Text = txtStatus.Text & "  Records Copied: " & Tuples & vbCrLf
        svr.LogEvent "Records Copied: " & Tuples, etMiniDebug
        txtStatus.SelStart = Len(txtStatus.Text)
        Me.Refresh
      End If
      
      '
      'Copy indexes if required
      '
      If chkIndexes.Value = 1 Then
             
        For Y = 0 To catLocal.Tables(lstData.List(X)).Indexes.Count - 1
        
          '1/14/2001 Rod Childers
          'If primary keys were created above, check each index
          'if it is a primary key do not recreate the index
          If chkPrimaryKey.Value = 1 And catLocal.Tables(lstData.List(X)).Indexes(Y).PrimaryKey = True Then
            '------Do nothing, skip this index, it was created above
          Else
                          
          '1/14/2001 Rod Childers
          'Keep ForeignKeys from being migrated as an index
          'loop throught all the Keys, if this index is a forigen key, don't create
          bIsForeignKey = False
          For i = 0 To catLocal.Tables(lstData.List(X)).Keys.Count - 1
            If catLocal.Tables(lstData.List(X)).Keys(i).Name = catLocal.Tables(lstData.List(X)).Indexes(Y) And catLocal.Tables(lstData.List(X)).Keys(i).Type = adKeyForeign Then
              'This is not an index, it is a ForeignKey, set flag
              bIsForeignKey = True
            End If
          Next i
            
              
          If bIsForeignKey = False Then
            txtStatus.Text = txtStatus.Text & "Creating index: " & catLocal.Tables(lstData.List(X)).Indexes(Y).Name & vbCrLf
            txtStatus.SelStart = Len(txtStatus.Text)
            Me.Refresh
            svr.LogEvent "Creating index: " & catLocal.Tables(lstData.List(X)).Indexes(Y).Name, etMiniDebug
            szQryStr = "CREATE "
              
            If catLocal.Tables(lstData.List(X)).Indexes(Y).Unique = True Then
              szQryStr = szQryStr & "UNIQUE "
            End If
                
            If Len(lstData.List(X) & "_" & catLocal.Tables(lstData.List(X)).Indexes(Y).Name) > 27 Then
              If chkLCaseIndexes.Value = 0 Then
                szQryStr = szQryStr & "INDEX " & fmtID(Mid(lstData.List(X) & "_" & catLocal.Tables(lstData.List(X)).Indexes(Y).Name & "_idx", 1, 26) & "-" & Y)
              Else
                szQryStr = szQryStr & "INDEX " & fmtID(LCase(Mid(lstData.List(X) & "_" & catLocal.Tables(lstData.List(X)).Indexes(Y).Name & "_idx", 1, 26) & "-" & Y))
              End If
            Else
              If chkLCaseIndexes.Value = 0 Then
                szQryStr = szQryStr & "INDEX " & fmtID(lstData.List(X) & "_" & catLocal.Tables(lstData.List(X)).Indexes(Y).Name & "_idx")
              Else
                szQryStr = szQryStr & "INDEX " & fmtID(LCase(lstData.List(X) & "_" & catLocal.Tables(lstData.List(X)).Indexes(Y).Name & "_idx"))
              End If
            End If
            If lVer >= 7.3 Then
              If chkLCaseTables.Value = 0 Then
                szQryStr = szQryStr & " ON " & fmtID(szNamespace) & "." & fmtID(lstData.List(X)) & " USING btree ("
              Else
                szQryStr = szQryStr & " ON " & fmtID(szNamespace) & "." & fmtID(LCase(lstData.List(X))) & " USING btree ("
              End If
            Else
              If chkLCaseTables.Value = 0 Then
                szQryStr = szQryStr & " ON " & fmtID(lstData.List(X)) & " USING btree ("
              Else
                szQryStr = szQryStr & " ON " & fmtID(LCase(lstData.List(X))) & " USING btree ("
              End If
            End If
            For W = 0 To catLocal.Tables(lstData.List(X)).Indexes(Y).Columns.Count - 1
              If chkLCaseColumns.Value = 0 Then
                szQryStr = szQryStr & fmtID(catLocal.Tables(lstData.List(X)).Indexes(Y).Columns(W).Name) & ", "
              Else
                szQryStr = szQryStr & fmtID(LCase(catLocal.Tables(lstData.List(X)).Indexes(Y).Columns(W).Name)) & ", "
              End If
            Next
            szQryStr = Mid(szQryStr, 1, Len(szQryStr) - 2) & ")"
            svr.Databases(szDatabase).Execute szQryStr
          End If
        End If
        
        Next
        szTemp1 = ""
        szQryStr = ""
        pbStatus.Value = pbStatus.Value + 1
        Me.Refresh
      End If
    
    Else
      txtStatus.Text = txtStatus.Text & "  " & "Table skipped - no columns found!" & vbCrLf
      svr.LogEvent "Table skipped - no columns found!", etMiniDebug
    End If
    
    '1/18/2003 John Wells
    If chkPerTableTrans.Value = 1 Then
      svr.LogEvent "Committing transaction...", etMiniDebug
      txtStatus.Text = txtStatus.Text & "Committing transaction..." & vbCrLf
      txtStatus.SelStart = Len(txtStatus.Text)
      Me.Refresh
      svr.Databases(szDatabase).Execute "COMMIT"
    End If
  Next
  
  '1/18/2003 John Wells Separate transactions for tables above, but one big 'un for foreign keys...
  If chkPerTableTrans.Value = 1 Then
    svr.Databases(szDatabase).Execute "BEGIN"
  End If
  
  '1/16/2001 Rod Childers
  'Migrate Eligible selected Foreign Keys
  'Making All Foreign keys Lower case
  For j = 0 To lstForeignKeys.ListCount - 1
    If lstForeignKeys.Selected(j) = True Then
      
      txtStatus.Text = txtStatus.Text & "Creating Foreign Key: " & lstForeignKeys.List(j) & vbCrLf
      txtStatus.SelStart = Len(txtStatus.Text)
      Me.Refresh
      svr.LogEvent "Creating Foreign Key: " & lstForeignKeys.List(j), etMiniDebug
   
        'loop through the tables and find which table it belongs to
        For X = 0 To catLocal.Tables.Count - 1
          If catLocal.Tables(X).Type = "TABLE" Then
            'Go through all the Keys in table
            For i = 0 To (catLocal.Tables(X).Keys.Count - 1)
                            
              If catLocal.Tables(X).Keys(i).Name = lstForeignKeys.List(j) And catLocal.Tables(X).Keys(i).Type = adKeyForeign Then
                If lVer >= 7.3 Then
                  If chkLCaseTables.Value = 0 Then
                    szQryStr = "ALTER TABLE " & fmtID(szNamespace) & "." & fmtID(catLocal.Tables(X).Name)
                  Else
                    szQryStr = "ALTER TABLE " & fmtID(szNamespace) & "." & fmtID(LCase(catLocal.Tables(X).Name))
                  End If
                Else
                  If chkLCaseTables.Value = 0 Then
                    szQryStr = "ALTER TABLE " & fmtID(catLocal.Tables(X).Name)
                  Else
                    szQryStr = "ALTER TABLE " & fmtID(LCase(catLocal.Tables(X).Name))
                  End If
                End If
                              
                'Reduce in size if necessary and ad _fk to end
                If lVer >= 7.3 Then
                  szTmpFKName = Left(lstForeignKeys.List(j), 60) & "_fk"
                  If chkLCaseIndexes.Value = 0 Then
                    szQryStr = szQryStr & " ADD CONSTRAINT " & fmtID(szTmpFKName) & " FOREIGN KEY("
                  Else
                    szQryStr = szQryStr & " ADD CONSTRAINT " & fmtID(LCase(szTmpFKName)) & " FOREIGN KEY("
                  End If
                Else
                  szTmpFKName = Left(lstForeignKeys.List(j), 28) & "_fk"
                  If chkLCaseIndexes.Value = 0 Then
                    szQryStr = szQryStr & " ADD CONSTRAINT " & fmtID(szTmpFKName) & " FOREIGN KEY("
                  Else
                    szQryStr = szQryStr & " ADD CONSTRAINT " & fmtID(LCase(szTmpFKName)) & " FOREIGN KEY("
                  End If
                End If
                
                'Get Columns involved with FK
                szRelatedCols = ""
                For Y = 0 To catLocal.Tables(X).Keys(i).Columns.Count - 1
                  If chkLCaseColumns.Value = 0 Then
                    szQryStr = szQryStr & fmtID(catLocal.Tables(X).Keys(i).Columns(Y).Name) & ","
                  Else
                    szQryStr = szQryStr & fmtID(LCase(catLocal.Tables(X).Keys(i).Columns(Y).Name)) & ","
                  End If
                  
                  'Get the related column name while we are on this comumn
                  'The Related column belongs to the Comumns collection in the table collection
                  'If it's blank, assume it should be the same as the fkey
                  If chkLCaseColumns.Value = 0 Then
                    szRelatedCols = szRelatedCols & fmtID(catLocal.Tables(X).Keys(i).Columns(catLocal.Tables(X).Keys(i).Columns(Y).Name).RelatedColumn) & ","
                  Else
                    szRelatedCols = szRelatedCols & fmtID(LCase(catLocal.Tables(X).Keys(i).Columns(catLocal.Tables(X).Keys(i).Columns(Y).Name).RelatedColumn)) & ","
                  End If
                Next Y
                
                'Trim extra , off end of column names, add ) to end
                szQryStr = Left(szQryStr, (Len(szQryStr) - 1)) & ")"
                szRelatedCols = Left(szRelatedCols, (Len(szRelatedCols) - 1)) & ")"
                If lVer >= 7.3 Then
                  If chkLCaseTables.Value = 0 Then
                    szQryStr = szQryStr & " REFERENCES " & fmtID(szNamespace) & "." & fmtID(catLocal.Tables(X).Keys(i).RelatedTable) & " (" & szRelatedCols
                  Else
                    szQryStr = szQryStr & " REFERENCES " & fmtID(szNamespace) & "." & fmtID(LCase(catLocal.Tables(X).Keys(i).RelatedTable)) & " (" & szRelatedCols
                  End If
                Else
                  If chkLCaseTables.Value = 0 Then
                    szQryStr = szQryStr & " REFERENCES " & fmtID(catLocal.Tables(X).Keys(i).RelatedTable) & " (" & szRelatedCols
                  Else
                    szQryStr = szQryStr & " REFERENCES " & fmtID(LCase(catLocal.Tables(X).Keys(i).RelatedTable)) & " (" & szRelatedCols
                  End If
                End If
                
                'Set action to do when referenced row is being deleted
                szQryStr = szQryStr & " ON DELETE "
                Select Case catLocal.Tables(X).Keys(i).DeleteRule
                  Case adRINone
                    szQryStr = szQryStr & "NO ACTION"
                  Case adRICascade
                    szQryStr = szQryStr & "CASCADE"
                  Case adRISetNull
                    szQryStr = szQryStr & "SET NULL"
                  Case adRISetDefault
                    szQryStr = szQryStr & "SET DEFAULT"
                End Select
                
                'Set action to do when referenced row is being Updated
                szQryStr = szQryStr & " ON UPDATE "
                Select Case catLocal.Tables(X).Keys(i).UpdateRule
                  Case adRINone
                    szQryStr = szQryStr & "NO ACTION"
                  Case adRICascade
                    szQryStr = szQryStr & "CASCADE"
                  Case adRISetNull
                    szQryStr = szQryStr & "SET NULL"
                  Case adRISetDefault
                    szQryStr = szQryStr & "SET DEFAULT"
                End Select
                
                svr.Databases(szDatabase).Execute szQryStr
                
              End If
            Next i
          End If
        Next X
    End If
  Next j
   
  '1/18/2003 John Wells
  'If we have foreign keys or if we're not doing per-table transactions, we need to commit here...
  If j > 0 Or chkPerTableTrans.Value = 0 Then
    svr.Databases(szDatabase).Execute "COMMIT"
  End If
  
  txtStatus.Text = txtStatus.Text & vbCrLf & "Migration finished at: " & Now & ", taking " & Fix((Timer - Start) * 100) / 100 & " seconds."
  txtStatus.SelStart = Len(txtStatus.Text)
  svr.LogEvent "Migration Completed!", etMiniDebug
  cmdOK.Enabled = True
  cmdOK.SetFocus
  EndMsg
  
  Exit Sub
Err_Handler:
  txtStatus.Text = txtStatus.Text & vbCrLf & "An error occured at: " & Now & ": " & vbCrLf & Err.Number & ": " & Replace(Err.Description, vbLf, vbCrLf) & vbCrLf & vbCrLf & "Rolling back..."
  txtStatus.SelStart = Len(txtStatus.Text)
  svr.Databases(szDatabase).Execute "ROLLBACK"
  txtStatus.Text = txtStatus.Text & " Done."
  txtStatus.SelStart = Len(txtStatus.Text)
  cmdNext.Visible = True
  cmdPrevious.Visible = True
  cmdMigrate.Visible = True
  cmdTypeMap.Visible = True
  cmdOK.Visible = False
  EndMsg
  If Err.Number <> 0 Then LogError Err.Number, Err.Description, App.Title & ":frmWizard.Migrate_Data"
End Sub

Private Sub tabWizard_Click(PreviousTab As Integer)
On Error GoTo Err_Handler
svr.LogEvent "Entering " & App.Title & ":frmWizard.tabWizard_Click()", etFullDebug
    
  If bButtonPress = False And bProgramPress = False Then
    bProgramPress = True
    tabWizard.Tab = PreviousTab
  Else
    bProgramPress = False
  End If
  bButtonPress = False
  
  Exit Sub
Err_Handler: If Err.Number <> 0 Then LogError Err.Number, Err.Description, App.Title & ":frmWizard.tabWizard_Click"
End Sub
